<template>
  <div class="overflow-hidden rounded-lg">
    <el-carousel
      id="home-carousel"
      trigger="click"
      :interval="4000"
      arrow="always"
      height="36.5vw"
      v-if="themeBanners.length"
    >
      <el-carousel-item v-for="(item, index) in themeBanners" :key="item.HtmlId">
        <nuxt-link :to="item.HyperLink" :id="ID.LOBBY_BANNER[item.HtmlId]">
          <div class="img-container pointer-events-none">
            <div
              class="blur-background"
              :style="{ 'background-image': 'url(' + item.ImagePath + ')' }"
            ></div>
            <img
              :src="item.ImagePath"
              class="mx-auto duration-700 relative"
              loading="lazy"
              @load="checkImageWidth"
            />
          </div>
        </nuxt-link>
      </el-carousel-item>
      <div
        class="bg-menu-r bottom-0 absolute right-0 left-0 h-[90px] z-[27]"
      ></div>
    </el-carousel>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent } from "vue";
import { store } from "@/store";
import {ID} from "~~/utils/constants";
import commonHelper from "@/utils/commonHelper";

const themePropertyKey = {
  banner: "lobby_banner_",
};

export default defineComponent({
  name: "Banner",
  setup() {
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const themeBanners = computed(() =>
      themePropertyHelper.getMultipleThemesProperties(
        themeProperties.value,
        themePropertyKey.banner
      )
    );
    const { getAssetImage } = commonHelper;
    const activeIndicator = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/active_indicator.png"
    )})`;
    const indicator = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/indicator.png"
    )})`;
    const checkImageWidth = (e: Event) => {
      const element = e.target as HTMLImageElement;
      if (element.naturalWidth < 1920) {
        element.classList.add("object-object-contain");
      } else {
        element.classList.add("object-cover");
      }
    };

    return {
      themeBanners,
      activeIndicator,
      indicator,
      checkImageWidth,
    };
  },
});
</script>

<style scoped>
.bg-menu-r {
  background-image: linear-gradient(
    180deg,
    transparent,
    rgba(103, 133, 180, 0),
    rgba(197, 219, 253, 0.43)
  );
}
</style>

<style lang="scss">
#home-carousel {
  .el-carousel__indicator {
    background-image: v-bind("indicator");
  }

  .el-carousel__indicator.is-active {
    background-image: v-bind("activeIndicator");
  }
}
</style>
